//
// Created by hoelshare on 22.05.17.
//

#include "GameClient.hpp"

void GameClient::createUIGameStart() {
    if (this->playerList) {
        this->playerList->Clear();
        Serial.println("GameClient::createUIGameStart - Clear");
    } else {
        this->playerList = new PlayerListMenu(9);
    }
    Serial.println("GameClient::createUIGameStart - new PlayerListMenu");
    playerList->setLeftAction([=]() { this->player->prevWeapon(); });
    playerList->setRightAction([=]() { this->player->nextWeapon(); });
//    playerList->setDownAction([=]() { this->player->reload(); });
    playerList->setEnterAction([=]() { this->player->shot(); });
    Serial.println("GameClient::createUIGameStart - set Lambdas");
    MenuItem *healthMI = new MenuItem("100%", []() {});
    MenuItem *armorMI = new MenuItem("100%", []() {});
    MenuItem *ammoMI = new MenuItem("10/10", []() {});
    MenuItem *nameMI = new MenuItem(player->getNickname(), []() {});
    player->setHealthMenuItem(healthMI);
    player->setArmorMenuItem(armorMI);
    player->setAmmoMenuItem(ammoMI);
    playerList->addMenuItem(new MenuItem("% Otter", []() {}));
    playerList->addMenuItem(healthMI);
//    playerList->addMenuItem(armorMI);
//    playerList->addMenuItem(ammoMI);
    playerList->addMenuItem(nameMI);
    Serial.println("GameClient::createUIGameStart - added Lambdas");
    ui->open(playerList);
    playerList->setDirty();
    Serial.println("GameClient::createUIGameStart - Ende");
}


void GameClient::startGame() {
    Serial.println("GameClient::startGame()");
    this->createUIGameStart();
    Serial.println("GameClient::startGame() - Ende");
}


void GameClient::joinGame(String ip) {
    badge->setVibrator(true);
    delay(200);
    badge->setVibrator(false);

    playerList->addMenuItem(new MenuItem(player->getNickname(), []() {}));

    ui->dispatchInput(badge->getJoystickState());
    ui->open(playerList);
    ui->draw();


    Serial.printf("Conn data:\n\tip: %s\n\tport: %d\n", ip.c_str(), SERVER_PORT);


    client = new WiFiClient();

    Serial.printf("Trying to conncet!\n");
    Serial.printf("My ip is %s\n", WiFi.localIP().toString().c_str());
    client->connect(ip.c_str(), SERVER_PORT);
    Serial.printf("client->connect\n");

    client->println(player->getNickname());

    //client->flush();

    String recv = client->readStringUntil('\n');
    Serial.printf("RECV: %s\n", recv.c_str());

    ui->dispatchInput(badge->getJoystickState());
    ui->draw();
}


void GameClient::update() {
//    Serial.println("GameClient - Update");

//    String lastHitBy;
//    int lastDamage;
//
//    if (wasHit(&lastHitBy, &lastDamage)){
//        player->hit(lastDamage);
//
//        tft.setCursor(20, 20);
//        tft.print("Hit by " + lastHitBy);
//    }

//    Serial.println("GameClient - Update - Ende");
}

bool GameClient::wasHit(String *nick, int *damage, bool enable) {
    // TODO: Write 'real' code
    *nick = "otter";
    *damage = 10;

    return enable;

}