//
// Created by hoelshare on 22.05.17.
//

#ifndef GPN_LASERTAG_GAMECLIENT_HPP
#define GPN_LASERTAG_GAMECLIENT_HPP

#include <GPNBadge.hpp>
#include "BadgeUI.h"
#include "PlayerListMenu.hpp"
#include "Player.hpp"

#define SERVER_PORT 4803

class GameClient {
public:
    GameClient(WindowSystem *ui, Badge *badge, Player *player) : ui(ui), badge(badge), player(player) {}

    virtual void update();

    void createUIGameStart();

    void startGame();

    void joinGame(String ip);

    bool wasHit(String* lastHitBy, int* lastDamage, bool enable = true);

private:
    WindowSystem *ui;
    Player *player;
    Badge *badge;
    char *host = "127.0.0.1"; // MaxArraySize
    PlayerListMenu *playerList = new PlayerListMenu(9);
    WiFiClient *client; // the client connected on client side
    bool reopen = false;
};

#endif //GPN_LASERTAG_GAMECLIENT_HPP
